X-Now-Playing headers for gnus

1.) add following to ~/.gnus

(defun xmms-now-playing ()
  (let ((track (shell-command-to-string "xmms-gnus")))
    (unless (string-equal "" track)
      (save-excursion
	(goto-char (point-min))
	(re-search-forward "^--text follows this line--")
	(forward-line 0)
	(insert "X-Now-Playing: " track "\n")))))

(add-hook 'message-setup-hook 'xmms-gnus)

  2.) compile below program and make it executable

/* compile with:  
 gcc -O2 -Wall `xmms-config --cflags --libs` -o xmms-now-playing xmms-now-playing.c
 */

#include <xmmsctrl.h>
#include <glib.h>

int
main (void)
{
  int n = -1;

  if ((n = xmms_remote_get_playlist_pos (0)) > -1)
    {
      char *title;

      if ((title = xmms_remote_get_playlist_title (0, n)))
	{
	  g_print ("%s", title);
	  g_free (title);
	}
    }
  return 0;
}
